#ifndef __DEFINEMENT__
#define __DEFINEMENT__

#define NB_MAX_PID 20


enum direction_e { haut, bas, guauche, droite};
enum type_figurant_e { Pieton, Terroriste, Fourgon};
enum type_joueur_e { HELICO, VOITURE};
typedef struct 
{
  long type;
  int file_message_id;
  int clefFM;
  int seg_memoire_id;
  int clefMP;
  int tab_semaphore_id;
  int clefTS;
} config_outil_IPC_t;

typedef struct {
  int x;
  int y;
} position_t;

typedef struct {
    char nom_complet[50];
    char lettre_aff;
    int bloquer;
    enum type_figurant_e type;
    position_t pos;
} Figurant_t;


typedef struct {
	char nom[50];
	enum type_joueur_e type;
	int pid;
	struct sockaddr_in IPdest;
	position_t pos;
} Joueur_t;
typedef struct {                    // type 1 == deplacement
  long type;
  char nom[50];
  enum type_figurant_e figurant;
  int figurantid;
  int argent;
  int joueur;                       // savoir si le message vient du joueur
  position_t position;
} MessageReseauDeplacement_t;       /// pour le client 1 = message deplacement  2 = message validation

typedef struct {                    // type 2 == ordre :)
  long type;
  int ordre;                        // 0 le client quite, 1 met tout en pause / play
} MessageReseauOrdre_t;             /// pour le client 1 = message deplacement  2 = message validation

typedef struct {                    //////////configmemoire/////////CARTE///////FIGURANT FOURGON//////FIGURANT PIETON
 int taille_carte_x;
 int taille_carte_y;
 int argent_restant;
 int argent_sauver;
 int nb_terroriste_arreter;
 int nb_figurant_pieton;
 int nb_figurant_fourgon;
 int pid_gestionnaire_connection_pere;
 Joueur_t joueur[2];
} config_memoire;


typedef struct {
  long type;
  int pid;
} demande_config_t;


typedef struct {
	int paquet_no;
	int paquet_total;
	int taille_utiliser_carte;
	char carte[500];
} MessageReseauCarte_t;             // message pour envoiyer la carte (éventuelement en plusieur fois)

typedef struct 
{
	long type;                       /// pour le client 1 = message deplacement  2 = message validation
	int figurantid;
	int joueur;                      // si le client recoi un paquet avec joueur a 1 alors il se deplacera
	position_t position;
} MessageValidation_t;




#endif