#define _SVID_SOURCE
#define _GNU_SOURCE
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include "thread.h"


/**
* Routine qui cree le bon nombre de thread pour chaque figurant 
* @param nbPieton Nombre de pieotn total a creer
* @param nbfourgon Nombre de fourgons total a creer
* @param memoire Pointeur vers le debut du segment memoire
*/
void creeThread(int nbPieton, int nbFourgon,void * memoire)
{

	int i;
	threadsPieton = malloc(sizeof(pthread_t)*nbPieton);
	threadsFourgon = malloc(sizeof(pthread_t)*nbFourgon);
	
	
	lockargent = malloc(sizeof(pthread_mutex_t));
	lockOutilsIPCFM = malloc(sizeof(pthread_mutex_t));
	
	

	if (pthread_mutex_init(lockOutilsIPCFM, NULL) != 0)
	{
		fprintf(stderr, "Erreur creation mutex\n");
		return;
	}
	if (pthread_mutex_init(lockargent, NULL) != 0)
	{
		fprintf(stderr, "Erreur creation mutex\n");
		return;
	}
	
	
	

	argumentThread_t *argument = malloc(sizeof(argumentThread_t)* (nbFourgon + nbPieton));


	int glo = 0;
	int id = 2;
	for(i = 0 ; i < nbFourgon; i++)
	{
		argument[glo].i = i;
		argument[glo].id = id;
		argument[glo].type = Fourgon;
		argument[glo].memoire_partager = memoire;
		
		if(pthread_create(&(threadsFourgon[i]), NULL, routineFourgon, (void *) &argument[glo]) != 0)
		{
			fprintf(stderr, "Erreur creation thread\n");
			return;
		}
		glo++;id++;
	}

	for(i = 0 ; i < nbPieton; i++)
	{

		argument[glo].i = i;
		argument[glo].id = id;
		argument[glo].type = Pieton;
		argument[glo].memoire_partager = memoire;
		
		if(pthread_create(&(threadsPieton[i]), NULL, routinePieton, (void *) &argument[glo]) != 0)
		{
			fprintf(stderr, "Erreur creation thread\n");
			return;
		}
		glo++;id++;
	}
	sleep(1);
}



/**
* Thread qui simule le comportement d'un Pieton 
* si il peut se deplacer il tente de le faire (toutes les 0.5s)
* sinon il se met en attente de la condition de liberation 
* @param arg Pointeur vers la structure des arguments du thread (argumentThread_t)
*/
void *routinePieton(void *arg) 
{

	// definition de la memoire
	argumentThread_t *argument = (argumentThread_t *) arg;
	int id_propre = argument->id;
	int noInMemory = argument->i;
	config_memoire * configuration = (config_memoire *) argument->memoire_partager;
	Figurant_t * fourgon = (void *)configuration + sizeof(config_memoire) 
	+ (sizeof(char)*(configuration->taille_carte_x*configuration->taille_carte_y));
	Figurant_t * pieton = (void *)fourgon + (sizeof(Figurant_t)*configuration->nb_figurant_fourgon);
	int position_trouver = 0;
	int x = 0;
	int y = 0;
	int *p_x,*p_y;
	char * nom;
	
	printf("thread crée id : %d \n",id_propre);
	/////////////////////INITIALISATION DE LA POSITION/////////////////
	while(position_trouver == 0)
	{
		x = rand() % configuration->taille_carte_x;
		y = rand() % configuration->taille_carte_y;
		
		verrouiller_deverrouiller_semaphore(configuration,-1,x, y);
		
		if(caseLibre(configuration,argument->type,x,y) == 1)
		{
			position_trouver = 1;
			pieton[noInMemory].lettre_aff = 'P';
			chargerNomfromFile(pieton,noInMemory);
			nom = pieton[noInMemory].nom_complet;
			pieton[noInMemory].type = Pieton;
			pieton[noInMemory].pos.x = x;
			pieton[noInMemory].pos.y = y;
			p_x = &(pieton[noInMemory].pos.x);
			p_y = &(pieton[noInMemory].pos.y);	      
		}
		verrouiller_deverrouiller_semaphore(configuration,1,x, y);      
	}
	
	MessageReseauDeplacement_t deplacement;
	deplacement.figurant = argument->type;
	deplacement.figurantid = id_propre;
	deplacement.joueur = 0;
	if(nom != NULL)
	{
		strcpy(deplacement.nom,nom);
	}
	////////////////////
	int etatsem = 0;
	while (1) 
	{
		usleep(500000);
		blocagePieton(id_propre,noInMemory,configuration, &deplacement);
		x = *p_x;
		y = *p_y;
		verrouiller_deverrouiller_semaphore(configuration,-1,x, y); // on verrouille la zone de la carte pour le deplacement 
		etatsem = 1;
		
		deplacementFigurant(id_propre,configuration, &deplacement,p_x,p_y);
		
		
		
		
		if(pieton[noInMemory].type == Pieton)
		{
			if(cambriolerBanque(configuration,*p_x,*p_y) == 1) // on verifie si on cambriole une banque toujours zone carte verrouillee
			{
				////////////ON A BESOIN D'UN MUTEX///////////////////
				//printf("cambriolage banque en cour\n");
				deplacement.figurant = Terroriste;
				pieton[noInMemory].type = Terroriste;
				
				// gestion de l'argent
				if(pieton[noInMemory].bloquer != 1)
				{
					pthread_mutex_lock (lockargent);
					int argentvoler  = rand() % 100;
					if(configuration->argent_restant - argentvoler < 0)
					{
						argentvoler = configuration->argent_restant;
						configuration->argent_restant = 0;
					}
					else
					{
						configuration->argent_restant -= argentvoler;
					}
					deplacement.argent = argentvoler;
					
					pthread_mutex_unlock (lockargent);
				}
				
				// on envoie un deplacement vers la meme case mais ca indiquera qu'on cahnge de type = Terroriste
				envoieDeplacement(id_propre,configuration,&deplacement);
				
				if(configuration->argent_restant == 0) // FIN DU JEUX
				{
					sleep(1);
					kill(configuration->pid_gestionnaire_connection_pere,SIGQUIT);
					kill(getpid(),SIGQUIT);
				}
				
				// on bloque le fourgon 
				int i,fourgonbloquer;
				for(i = 0; i < configuration->nb_figurant_fourgon ; i++)
				{
					if(fourgon[i].pos.x == *p_x && fourgon[i].pos.y == *p_y) 
					{
						fourgon[i].bloquer = 1;
						fourgonbloquer = i;
					}
				}
				verrouiller_deverrouiller_semaphore(configuration,1,x, y); // on deverrouille le terrain (le fourgon restera bloque)
				etatsem = 0;
				// on s'endort (le tempo est regule grace au main du serveur (toutes les secondes))
				
				int temps_cambriolage = 5; // temps de cambriolage definie a 5 sec
				while ( temps_cambriolage != 0) 
				{
					sleep(1);
					temps_cambriolage--;
					
					// SI UN HELICO INTERVIENT on bloque
					if(configuration->joueur[0].type == HELICO && configuration->joueur[0].pos.x == *p_x && configuration->joueur[0].pos.y == *p_y)
					{
						pieton[noInMemory].bloquer = 1;
					}
					if(configuration->joueur[1].type == HELICO && configuration->joueur[1].pos.x == *p_x && configuration->joueur[1].pos.y == *p_y)
					{
						pieton[noInMemory].bloquer = 1;
					}
					
					// si on se fait arreter
					if(pieton[noInMemory].bloquer == 1)
					{
						temps_cambriolage = 0; // on quitte le cambriolage on a ete arrete 
					}
				}
				// debloquage fourgon 
				fourgon[fourgonbloquer].bloquer = 0;	    
				//printf("cambriolage termine\n");
			}
		}
		else
		{
			if(configuration->joueur[0].type == VOITURE && configuration->joueur[0].pos.x == *p_x && configuration->joueur[0].pos.y == *p_y)
			{
				pieton[noInMemory].bloquer = 1;
			}
			if(configuration->joueur[1].type == VOITURE && configuration->joueur[1].pos.x == *p_x && configuration->joueur[1].pos.y == *p_y)
			{
				pieton[noInMemory].bloquer = 1;
			}
		}
		
		if(etatsem == 1)
		{
			verrouiller_deverrouiller_semaphore(configuration,1,x, y); 
			etatsem = 0;
		}
		
		if(pieton[noInMemory].type == Terroriste)
		{
			if(remiseDuButin(configuration,*p_x,*p_y) == 1)
			{
				deplacement.figurant = Pieton;
				pieton[noInMemory].type = Pieton;
			}
		}
		
		if(pieton[noInMemory].bloquer != 1)
		{
			libererPrisonnier(configuration,*p_x,*p_y);
		}
		
	}
	return NULL;
}


/**
* Thread qui simule le comportement d'un Fourgon
* On tente un deplacement toute les 0.5s tant qu'on est pas bloque
* @param arg Pointeur vers la structure des arguments du thread (argumentThread_t)
*/
void *routineFourgon(void *arg) 
{
	
	// definition de la memoire
	argumentThread_t *argument = (argumentThread_t *) arg;
	int id_propre = argument->id;
	int noInMemory = argument->i;
	config_memoire * configuration = (config_memoire *) argument->memoire_partager;
	Figurant_t * fourgon = (void *)configuration + sizeof(config_memoire) 
	+ (sizeof(char)*(configuration->taille_carte_x*configuration->taille_carte_y));
	int position_trouver = 0;
	int x = 0;
	int y = 0;
	int *p_x,*p_y;

	printf("thread crée id : %d \n",id_propre);
	/////////////////////INITIALISATION DE LA POSITION/////////////////
	while(position_trouver == 0)
	{
		x = rand() % configuration->taille_carte_x;
		y = rand() % configuration->taille_carte_y;
		
		verrouiller_deverrouiller_semaphore(configuration,-1,x, y);
		
		if(caseLibre(configuration,argument->type,x,y) == 1)
		{
			position_trouver = 1;
			fourgon[noInMemory].lettre_aff = 'F';
			fourgon[noInMemory].type = Fourgon;
			fourgon[noInMemory].pos.x = x;
			fourgon[noInMemory].pos.y = y;
			p_x = &(fourgon[noInMemory].pos.x);
			p_y = &(fourgon[noInMemory].pos.y);   
		}
		verrouiller_deverrouiller_semaphore(configuration,1,x, y);      
	}
	
	MessageReseauDeplacement_t deplacement;
	deplacement.figurant = argument->type;
	deplacement.figurantid = id_propre;
	deplacement.joueur = 0;
	

	//////////////////////
	
	while (1) 
	{
		usleep(500000);
		x = *p_x;
		y = *p_y;
		verrouiller_deverrouiller_semaphore(configuration,-1,x, y); // on a reussit a verrouiller le semaphore c'est que personne fait rien

		if(blocageFourgon(noInMemory,configuration) == 1) // met en veille le thread de deverrouille les semaphores si il est bloque par un terroriste
		{
			printf("fin blocage fourgon\n");
			verrouiller_deverrouiller_semaphore(configuration,-1,x, y); // si on a ete bloque il faut reverrouiller les semaphores après pour se deplacer
		}
		deplacementFigurant(id_propre,configuration, &deplacement,p_x,p_y); //ne touche pas au semaphore 

		verrouiller_deverrouiller_semaphore(configuration,1,x, y);

	}

	return NULL;
}


/**
* Fonction qui verifie si une case est libre, ou occupe par quelque chose d'autre 
* @param configuration_jeu Pointeur vers debut de la configuration du segment memoire
* @param type Type de Figurant 
* @param x Coordonnee x du deplacement
* @param y Coordonnee y du deplacement
* @return 1 si la case est libre sinon 0
*/
int caseLibre(config_memoire * configuration_jeu,enum type_figurant_e type,int x,int y)
{

	int position = (x * configuration_jeu->taille_carte_y) + y;
	
	int i;
	if(x >= configuration_jeu->taille_carte_x || x < 0 || y >= configuration_jeu->taille_carte_y || y < 0)
	{
		return 0;
	}
	
	char * carte  = (void * )configuration_jeu + sizeof(config_memoire);
	Figurant_t * fourgon = (void *)carte + (sizeof(char)*(configuration_jeu->taille_carte_x*configuration_jeu->taille_carte_y));
	Figurant_t * pieton = (void *)fourgon + (sizeof(Figurant_t)*configuration_jeu->nb_figurant_fourgon);
	
	
	if(carte[position] == 'X' || carte[position] == '$' || carte[position] == '#' || carte[position] == 'R')
	{
		return 0;
	}
	
	if(type == Fourgon)
	{
		for(i = 0; i < configuration_jeu->nb_figurant_fourgon ; i++)
		{
			if(fourgon[i].pos.x == x && fourgon[i].pos.y == y) // les fourgons ne peuvent se marcher dessus
			return 0;
		}
		return 1; // si c'est un fourgon il est pas bloque par n'importe quoi 
	}
	
	for(i = 0; i < configuration_jeu->nb_figurant_pieton ; i++)
	{
		if(pieton[i].pos.x == x && pieton[i].pos.y == y)
		return 0;
	}
	
	return 1;
}

/**
* Fonction qui bloque/debloque la ou les zone(s) de la carte 
* en fonction des coordonnees ou je me trouve
* @param config_memoire* Pointeur vers la structure de configuration de mon jeu (segment memoire)
* @param operation Operation que je souhaite faire bloquer = 1 debloquer=-1
* @param x Position x sur la carte
* @param y Position y sur la carte
*/
void verrouiller_deverrouiller_semaphore(config_memoire * configuration_jeu,int operation,int x, int y)
{
	if(operation < 0 )
	operation = -1;
	else
	operation = 1;
	
	int zone_y = (configuration_jeu->taille_carte_y / 4);
	
	struct sembuf op[5];
	// des puije pour 

	op[0].sem_op = operation;
	op[0].sem_flg = 0;
	op[0].sem_num = 0;
	op[1].sem_op = operation;
	op[1].sem_flg = 0;
	op[1].sem_num = 0;
	op[2].sem_op = operation;
	op[2].sem_flg = 0;
	op[2].sem_num = 0;
	op[3].sem_op = operation;
	op[3].sem_flg = 0;
	op[3].sem_num = 0;
	op[4].sem_op = operation;
	op[4].sem_flg = 0;
	op[4].sem_num = 0;
	
	
	int zone_x_sem = (x / 4); 
	int zone_y_sem = (y / 4);
	
	int sem_base = zone_x_sem * zone_y + zone_y_sem;
	
	op[0].sem_num = sem_base;
	
	//0 bas, 1 haut, 2 guauche, 3 droite
	
	int i = 1;
	
	// si on est pas a la limite en bas
	if((x + 1) < configuration_jeu->taille_carte_x && ((((x+1) / 4) * zone_y) + zone_y_sem) != sem_base)
	{
		op[i].sem_num = (((x+1) / 4) * zone_y) + zone_y_sem;
		i++;
	}
	
	if((x - 1) >= 0 && (((((x-1) / 4) * zone_y) + zone_y_sem) != sem_base))
	{
		op[i].sem_num = (((x-1) / 4) * zone_y) + zone_y_sem;
		i++;
	}
	
	if((y - 1) >= 0 && ((zone_x_sem * zone_y) + ((y-1) / 4)) != sem_base)
	{
		op[i].sem_num = (zone_x_sem * zone_y) + ((y-1) / 4);
		i++;
	}
	if((y + 1) < configuration_jeu->taille_carte_y && ((zone_x_sem * zone_y) + ((y+1) / 4)) != sem_base)
	{
		op[i].sem_num = (zone_x_sem * zone_y) + ((y+1) / 4);
		i++;
	}
	// semop est atomique :) il sort couvert contre les threads :D
	if(semop(conf_outil_IPC->tab_semaphore_id, op, i) == -1) 
	{
		perror("Erreur lors de l'operation sur le semaphore \n");
		msgctl(conf_outil_IPC->file_message_id,IPC_RMID,NULL);
		shmctl(conf_outil_IPC->seg_memoire_id,IPC_RMID,NULL);
		semctl(conf_outil_IPC->tab_semaphore_id,0,IPC_RMID,NULL);
		exit(EXIT_FAILURE);
	}
}

/**
* Affecte un nom aleatoirement au figurant grace a un base de donnee
* @param pieton Figurant dont on doit affecter un nom
* @param noInMemory Place des informations concernant le figurant dans le segment memoire
*/
void chargerNomfromFile(Figurant_t * pieton,int noInMemory)
{
	FILE * pFile;
	pFile = fopen ("nom","r");
	if (pFile==NULL)
	{
		printf("Erreur lors de l'ouverture du fichier\n");
		exit(EXIT_FAILURE);
	}
	int i = 0;
	while(fscanf(pFile, "%49s", pieton[noInMemory].nom_complet) != EOF)
	{
		if(i == noInMemory )
		{
			fclose(pFile);
			return;
		}
		i++;
	}
}

